import React from 'react';

var useDebounce = function (data, interval) {
    var _a = React.useState(data), liveData = _a[0], setLiveData = _a[1];
    React.useEffect(function () {
        if (typeof window !== "undefined") {
            var handler_1 = window.setTimeout(function () {
                setLiveData(data);
            }, interval);
            return function () {
                window.clearTimeout(handler_1);
            };
        }
    }, [data, interval]);
    return liveData;
};

var Autosave = function (_a) {
    var data = _a.data, onSave = _a.onSave, _b = _a.interval, interval = _b === void 0 ? 2000 : _b, _c = _a.element, element = _c === void 0 ? React.createElement(React.Fragment, null) : _c;
    var initialRender = React.useRef(true);
    var debouncedValueToSave = useDebounce(data, interval);
    React.useEffect(function () {
        if (initialRender.current) {
            initialRender.current = false;
        }
        else {
            if (debouncedValueToSave) {
                onSave(debouncedValueToSave);
            }
        }
    }, [debouncedValueToSave, interval, onSave]);
    return element;
};

var useAutosave = function (_a) {
    var data = _a.data, onSave = _a.onSave, _b = _a.interval, interval = _b === void 0 ? 2000 : _b;
    var initialRender = React.useRef(true);
    var debouncedValueToSave = useDebounce(data, interval);
    React.useEffect(function () {
        if (initialRender.current) {
            initialRender.current = false;
        }
        else {
            if (debouncedValueToSave) {
                onSave(debouncedValueToSave);
            }
        }
    }, [debouncedValueToSave, interval, onSave]);
};

export { Autosave, useAutosave, useDebounce };
